//server: ca. 9%   client: ca. 12,4%

//example:     7-x  ==  7 XOR x (in java 7^x  )
import ewe.sys.Vm;

public class XOR_7_minus_x implements OptiTest
{
  private static final String name="'7-x' replaced by '7 xor x'";


  public void findAndSetNumberOfRuns(final int milliSecondsUnoptimised)
  {
    long time;
    numberOfRuns=1;
    for(int i=100; 0<i--;)
    {
      runUnoptimisedVersion();
      runOptimisedVersion();
    }//next i


    int count=0;

    time=System.currentTimeMillis() ;
    while(milliSecondsUnoptimised>(int)(System.currentTimeMillis() -time))
    { runUnoptimisedVersion();
      runOptimisedVersion();
      count++;
    }//wend
    numberOfRuns=count;

//System.err.println(count+" ("+getTestname()+")");//                    //DEBUG

  }//end-method
  private static int numberOfRuns=1;


  public final String getTestname()
  {
    return name;
  }



  public static void main(final String[] args)
  {
    (new XOR_7_minus_x()).runForEver();
  }



  public void runForEver()
  {
    //!!!not supported for EWE
  }//end-method



  public int runUnoptimisedVersion()
  {
    long time;
    //the mesured call
    time=System.currentTimeMillis() ;
//    System.err.println("norm: (XOR_7_minus_x)"+minus_X(numberOfRuns));
    minus_X(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


  public int runOptimisedVersion()
  {
    long time;
    //the mesured call
    time=System.currentTimeMillis() ;
//    System.err.println("opti: (XOR_7_minus_x)"+xor_X(numberOfRuns));
    xor_X(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  private static int minus_X(int anz)
  {
    int erg=7;
    while(0<anz--)
    {
      for(int x=3; 0<=x; x--)
        erg+=3-x;
      for(int x=7; 0<=x; x--)
        erg+=7-x;
      for(int x=15; 0<=x; x--)
        erg+=15-x;
      for(int x=31; 0<=x; x--)
        erg+=31-x;
      for(int x=63; 0<=x; x--)
        erg+=63-x;
      for(int x=127; 0<=x; x--)
        erg+=127-x;
      for(int x=255; 0<=x; x--)
        erg+=255-x;
      for(int x=511; 0<=x; x--)
        erg+=511-x;
      for(int x=1023; 0<=x; x--)
        erg+=1023-x;
      for(int x=2047; 0<=x; x--)
        erg+=2047-x;
      for(int x=4095; 0<=x; x--)
        erg+=4095-x;
      for(int x=8191; 0<=x; x--)
        erg+=8191-x;
      for(int x=16383; 0<=x; x--)
        erg+=16383-x;
      for(int x=32767; 0<=x; x--)
        erg+=32767-x;
      for(int x=65535; 0<=x; x--)
        erg+=65535-x;
      for(int x=131071; 0<=x; x-=113)
        erg+=131071-x;
      for(int x=262143; 0<=x; x-=113)
        erg+=262143-x;
      for(int x=524287; 0<=x; x-=213)
        erg+=524287-x;
  //      for(int x=1048575; 0<=x; x--)
  //        erg+=1048575-x;
  //    for(int x=2097151; 0<=x; x-=113)
  //      erg+=2097151-x;
  //      for(int x=4194303; 0<=x; x--)
  //        erg+=4194303-x;
  //    for(int x=8388607; 0<=x; x-=113)
  //      erg+=8388607-x;
  //      for(int x=16777215; 0<=x; x--)
  //        erg+=16777215-x;
  //    for(int x=33554431; 0<=x; x-=113)
  //      erg+=33554431-x;
  //      for(int x=67108863; 0<=x; x--)
  //        erg+=67108863-x;
  //    for(int x=134217727; 0<=x; x-=43)
  //      erg+=134217727-x;
  //      for(int x=268435455; 0<=x; x--)
  //        erg+=268435455-x;
  //    for(int x=536870911; 0<=x; x-=113)
  //      erg+=536870911-x;
  //    for(int x=1073741823; 0<=x; x-=113)
  //      erg+=1073741823-x;
      for(int x=2147483647; 0<=x; x-=1793)
        erg+=2147483647-x;
    }//wend
    return erg;
  }//end-method

  private static int xor_X(int anz)
  {
    int erg=7;
    while(0<anz--)
    {
      for(int x=3; 0<=x; x--)
        erg+=3^x;
      for(int x=7; 0<=x; x--)
        erg+=7^x;
      for(int x=15; 0<=x; x--)
        erg+=15^x;
      for(int x=31; 0<=x; x--)
        erg+=31^x;
      for(int x=63; 0<=x; x--)
        erg+=63^x;
      for(int x=127; 0<=x; x--)
        erg+=127^x;
      for(int x=255; 0<=x; x--)
        erg+=255^x;
      for(int x=511; 0<=x; x--)
        erg+=511^x;
      for(int x=1023; 0<=x; x--)
        erg+=1023^x;
      for(int x=2047; 0<=x; x--)
        erg+=2047^x;
      for(int x=4095; 0<=x; x--)
        erg+=4095^x;
      for(int x=8191; 0<=x; x--)
        erg+=8191^x;
      for(int x=16383; 0<=x; x--)
        erg+=16383^x;
      for(int x=32767; 0<=x; x--)
        erg+=32767^x;
      for(int x=65535; 0<=x; x--)
        erg+=65535^x;
      for(int x=131071; 0<=x; x-=113)
        erg+=131071^x;
      for(int x=262143; 0<=x; x-=113)
        erg+=262143^x;
      for(int x=524287; 0<=x; x-=213)
        erg+=524287^x;
  //      for(int x=1048575; 0<=x; x--)
  //        erg+=1048575^x;
  //    for(int x=2097151; 0<=x; x-=113)
  //      erg+=2097151^x;
  //      for(int x=4194303; 0<=x; x--)
  //        erg+=4194303^x;
  //    for(int x=8388607; 0<=x; x-=113)
  //      erg+=8388607^x;
  //      for(int x=16777215; 0<=x; x--)
  //        erg+=16777215^x;
  //    for(int x=33554431; 0<=x; x-=113)
  //      erg+=33554431^x;
  //      for(int x=67108863; 0<=x; x--)
  //        erg+=67108863^x;
  //    for(int x=134217727; 0<=x; x-=43)
  //      erg+=134217727^x;
  //      for(int x=268435455; 0<=x; x--)
  //        erg+=268435455^x;
  //    for(int x=536870911; 0<=x; x-=113)
  //      erg+=536870911^x;
  //    for(int x=1073741823; 0<=x; x-=113)
  //      erg+=1073741823^x;
      for(int x=2147483647; 0<=x; x-=1793)
        erg+=2147483647^x;
    }//wend
    return erg;
  }//end-method

}//end-class
